//
//  CoDetailViewController.m
//  konohana_test
//
//  Created by kunii on 09/12/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "CoDetailViewController.h"
#import "UpdateTrigger.h"

/*
	コメント付き支持クラス
*/
@interface Vote : NSObject {
	int			ID;				//	データベース用識別子
	NSString*	comment;		//	支持に対する追記
}
@property (nonatomic, assign) int		ID;
@property (nonatomic, retain) NSString*	comment;
@end

@implementation Vote
@synthesize ID;
@synthesize comment;

-(void)dealloc {
	[comment release];
	[super dealloc];
}
@end

@implementation CoDetailViewController
@synthesize image;
@synthesize db;
@synthesize comment;
@synthesize contributeID;
@synthesize sugestionID;
@synthesize own;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
	支持ボタンが押されたので、データベースに支持を追加。
	voteCommentView.textがnilで無い場合、コメント付きの支持として登録される。
	その後、自分をナビゲーションバーからpopして呼び出し先UIViewController（提案ビューコントローラ）に戻る。
*/
- (void)doVote {
	[db addVote:contributeID suggestionID:sugestionID comment:voteCommentView.text];
	[self.navigationController popViewControllerAnimated:YES];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	CGRect r = self.view.bounds;
	r.size.width = 100;
	r.size.height = 100;
	r = CGRectOffset(r, 10, 10);
	UIImageView* iview = [[UIImageView alloc] initWithFrame:r];
	[self.view addSubview:iview];

	r = CGRectOffset(r, r.size.width + 10, 0);
	UITextView* txview = [[UITextView alloc] initWithFrame:r];
	[self.view addSubview:txview];
	
	r = self.view.bounds;
	r.origin.y += 120;
	r.size.height = 30;
	voteCommentView = [[UITextField alloc] initWithFrame:r];
	voteCommentView.borderStyle = UITextBorderStyleRoundedRect;
	voteCommentView.placeholder = @"コメントするならここに";
	
	[self.view addSubview:voteCommentView];

	r.origin.y += r.size.height;
	r.size.height = self.view.bounds.size.height - r.origin.y;
	UITableView* tview = [[UITableView alloc] initWithFrame:r];

	tview.autoresizingMask = UIViewAutoresizingFlexibleHeight;
	
	[self.view addSubview:tview];

	imageView = iview;
	commentView = txview;
	voteTableView = tview;

	commentView.text = comment;
	voteTableView.allowsSelection = NO;
	voteTableView.dataSource = self;
	voteTableView.delegate = self;

	//	アップデート機能の追加。
	updateTrigger = [[UpdateTrigger alloc] init];
	[updateTrigger adapteTrigger:voteTableView];
	updateTrigger.delegte = self;


	imageView.image = image;

	[iview release];
	[txview release];
	[tview release];

	//	支持ボタンの追加
	self.navigationItem.rightBarButtonItem
		= [[[UIBarButtonItem alloc]
			 initWithTitle:@"支持する"
			 style:UIBarButtonItemStyleDone
			 target:self
			 action:@selector(doVote)] autorelease];
	if (result == nil)
		result = [[NSMutableArray alloc] init];
}

//	アップデート機能の追加のために以下の3つのメソッドでupdateTriggerに連携する。
- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView {
	[updateTrigger scrollViewWillBeginDragging:scrollView];
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {               // any offset changes
	[updateTrigger scrollViewDidScroll:scrollView];
}

- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate {
	[updateTrigger scrollViewDidEndDragging:scrollView willDecelerate:decelerate];
}

/*
	テーブルを更新する。
*/
-(void)update:(BOOL)foword {
	db.dbDelegate = self;
	int ID = 0;
	if ([result count]) {
		Vote* instance = [result objectAtIndex:[result count] - 1];
		ID = instance.ID;
	}
	if (foword || (ID == 0)) {
		[result removeAllObjects];
		[db connectForVote:contributeID suggestion:sugestionID];
	} else {
		[db connectForVote:contributeID suggestion:sugestionID vote:ID forword:NO];
	}
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[updateTrigger release];
	[voteCommentView release];
	[result release];
	[image release];
	[comment release];
    [super dealloc];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [result count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath 
{
	static NSString *CellIdentifier = @"CoDetailCell";    
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
	}
	Vote* c = [result objectAtIndex:indexPath.row];
	cell.textLabel.text = c.comment;
    return cell;
}

/*
	表示に合わせてデータベース再建策
*/
-(void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	db.dbDelegate = self;
	[result removeAllObjects];
	[db connectForVote:contributeID suggestion:sugestionID];
	[voteTableView deselectRowAtIndexPath:[voteTableView indexPathForSelectedRow] animated:YES];
}

//	接続完了。
-(void)terminate
{
	[updateTrigger adjust:[result count] * 44.0];
	[voteTableView reloadData];
}

/*
	コメント付き支持発見
*/
-(void)arrivedVote:(int)inID comment:(NSString*)inComment {
	Vote* instance = [[[Vote alloc] init] autorelease];
	instance.ID = inID;
	instance.comment = inComment;
	[result addObject:instance];
}

/*
	項目削除。
*/
- (void)tableView:(UITableView *)tableView 
	commitEditingStyle:(UITableViewCellEditingStyle)editingStyle 
	forRowAtIndexPath:(NSIndexPath *)indexPath 
{
	Vote* c = [result objectAtIndex:indexPath.row];
	[db removeVote:contributeID suggestionID:sugestionID voteID:c.ID];
	[result removeObjectAtIndex:indexPath.row];
	[tableView deleteRowsAtIndexPaths:
		[NSArray arrayWithObject:indexPath] 
		withRowAnimation:UITableViewRowAnimationTop];
}

/*
	自分が投稿した花に対する、提案、支持は編集可能にする
*/
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
	return own;
}

- (CGFloat)tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section {
	return 200;
}

@end
