//
//  DetailViewController.m
//  konohana_test
//
//  Created by kunii on 09/11/22.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "DetailViewController.h"
#import "CoDetailViewController.h"
#import "UpdateTrigger.h"
#import "SuggestionCell.h"

/*
	提案クラス
*/
@interface Suggestion : NSObject {
	int			ID;			//	データベース用識別子
	NSString*	name;		//	提案名
	NSString*	comment;	//	提案に対する追記
	int			voteCount;	//	支持数
}
@property (nonatomic, assign) int		ID;
@property (nonatomic, retain) NSString*	name;
@property (nonatomic, retain) NSString*	comment;
@property (nonatomic, assign) int		voteCount;
@end

@implementation Suggestion
@synthesize ID;
@synthesize name;
@synthesize comment;
@synthesize voteCount;

-(void)dealloc {
	[name release];
	[comment release];
	[super dealloc];
}
@end

@implementation DetailViewController
@synthesize comment;
@synthesize image;
@synthesize db;
@synthesize contributeID;
@synthesize own;
@synthesize suggestionCell;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
	新しい提案を登録
*/
- (void)newSuggestion {
	NewFlowerNameViewController* ctl =
		[[NewFlowerNameViewController alloc] initWithNibName:@"NewFlowerNameViewController" bundle:nil];
	ctl.image = image;
	ctl.comment = comment;
	ctl.newflowerNameDelegate = self;
	//	ナビゲーションコントローラ
	UINavigationController* naviCon = [[UINavigationController alloc] 
		initWithRootViewController:ctl];
	//	モーダルビューとして表示。
	[self presentModalViewController:naviCon animated:YES];
	//	presentModalViewControllerでcontroller側の管理下に入った。そのため
	//	こちらでは管理する必要がなくなったので解放する。
	[ctl release];
	[naviCon release];
}

-(void)newFlowerName:(NSString*) inName comment:(NSString*)inComment {
	if (inName) {
		[db addSuggestion:contributeID name:inName comment:inComment];
		[result removeAllObjects];
		[db connectForSuggestion:contributeID];
	}
	[self dismissModalViewControllerAnimated:YES];	
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	commentView.text = comment;
	sugestionTableView.dataSource = self;
	sugestionTableView.delegate = self;

	//	アップデート機能の追加。
	updateTrigger = [[UpdateTrigger alloc] init];
	[updateTrigger adapteTrigger:sugestionTableView];
	updateTrigger.delegte = self;

	imageView.image = image;	
	//	新規提案ボタンの追加
	self.navigationItem.rightBarButtonItem
		= [[[UIBarButtonItem alloc]
			 initWithBarButtonSystemItem:UIBarButtonSystemItemAdd
			 target:self 
			 action:@selector(newSuggestion)] autorelease];
	if (result == nil)
		result = [[NSMutableArray alloc] init];
}

//	アップデート機能の追加のために以下の3つのメソッドでupdateTriggerに連携する。
- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView {
	[updateTrigger scrollViewWillBeginDragging:scrollView];
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {               // any offset changes
	[updateTrigger scrollViewDidScroll:scrollView];
}

- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate {
	[updateTrigger scrollViewDidEndDragging:scrollView willDecelerate:decelerate];
}

/*
	テーブルを更新する。
*/
-(void)update:(BOOL)foword {
	db.dbDelegate = self;
	int ID = 0;
	if ([result count]) {
		Suggestion* instance = [result objectAtIndex:[result count] - 1];
		ID = instance.ID;
	}
	if (foword || (ID == 0)) {
		[result removeAllObjects];
		[db connectForSuggestion:contributeID];
	} else {
		[db connectForSuggestion:contributeID suggestion:ID forword:NO];
	}
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[result release];
	[comment release];
	[image release];
    [super dealloc];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [result count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath 
{
	static NSString *CellIdentifier = @"DetailCell";    
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		[[NSBundle mainBundle] loadNibNamed:@"SuggestionCell" owner:self options:nil];
		cell = suggestionCell;
		self.suggestionCell = nil;
	}
	Suggestion* instance = [result objectAtIndex:indexPath.row];
	SuggestionCell* scell = (SuggestionCell*)cell;
	scell.nameLabel.text = instance.name;
	scell.voteCountLabel.text = [NSString stringWithFormat:@"%d", instance.voteCount];
    return cell;
}

/*
	提案項目の一つが選ばれた。
*/
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)newIndexPath
{
	UITableViewCell* cell = [tableView cellForRowAtIndexPath:newIndexPath];
	CoDetailViewController* ctl = [[CoDetailViewController alloc] initWithNibName:@"CoDetailViewController" bundle:nil];
	ctl.title = cell.textLabel.text;
	ctl.image = image;

	ctl.db = db;

	Suggestion* instance = [result objectAtIndex:newIndexPath.row];
	ctl.contributeID = contributeID;
	ctl.sugestionID = instance.ID;
	ctl.comment = instance.comment;
	ctl.own = own;

	[self.navigationController pushViewController:ctl animated:YES];
	[ctl release];
}

/*
	表示に合わせてデータベース再建策
*/
-(void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	db.dbDelegate = self;
	[result removeAllObjects];
	[db connectForSuggestion:contributeID];
	[sugestionTableView deselectRowAtIndexPath:[sugestionTableView indexPathForSelectedRow] animated:YES];
}

//	接続完了。
-(void)terminate {
	if ([result count] > 0) {
		Suggestion* instance = [result objectAtIndex:0];
		self.title = instance.name;
	}
	[updateTrigger adjust:[result count] * 44.0];
	[sugestionTableView reloadData];
}

/*
	提案が見つかった
*/
-(void)arrivedSuggestion:(int)inID name:(NSString*)name comment:(NSString*)inComment vote:(int)count {
	Suggestion* instance = [[[Suggestion alloc] init] autorelease];
	instance.ID = inID;
	instance.name = name;
	instance.comment = inComment;
	instance.voteCount = count;
	[result addObject:instance];
}

/*
	項目削除。
*/
- (void)tableView:(UITableView *)tableView 
	commitEditingStyle:(UITableViewCellEditingStyle)editingStyle 
	forRowAtIndexPath:(NSIndexPath *)indexPath {
	Suggestion* instance = [result objectAtIndex:indexPath.row];
	[db removeSuggestion:contributeID suggestionID:instance.ID];
	[result removeObjectAtIndex:indexPath.row];
	[tableView deleteRowsAtIndexPaths:
		[NSArray arrayWithObject:indexPath] 
		withRowAnimation:UITableViewRowAnimationTop];
}

/*
	自分が投稿した花に対する、提案は編集可能にする
*/
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
	return own;
}
@end

