//
//  FirstViewController.m
//  konohana_test
//
//  Created by kunii on 09/11/11.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "FirstViewController.h"
#import "DetailViewController.h"
#import "UpdateTrigger.h"

/*
	投稿クラス
*/
@interface Contribute : NSObject {
	int			ID;				//	データベース用識別子
	UIImage*	photo;			//	花の写真
	NSString*	name;			//	支持数の一番多い提案
	NSString*	comment;		//	投稿時の付加情報
	BOOL		own;			//	自分の投稿ならYES
}
@property (nonatomic, assign) int		ID;
@property (nonatomic, retain) UIImage*	photo;
@property (nonatomic, retain) NSString*	name;
@property (nonatomic, retain) NSString*	comment;
@property (nonatomic, assign) BOOL		own;
@end

@implementation Contribute
@synthesize ID;
@synthesize photo;
@synthesize name;
@synthesize comment;
@synthesize own;

-(void)dealloc {
	[photo release];
	[name release];
	[comment release];
	[super dealloc];
}
@end


#define TABLE_ROW_HEIGHT 100
enum {
	tag_Photo = 1,
	tag_Name,
	tag_Comment
};

@implementation FirstViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

/*
	新しい投稿
*/
- (void)doNewFlower {
	NewFlowerViewController* contributionViewController = 
		[[NewFlowerViewController alloc] 
		initWithNibName:@"NewFlowerViewController" bundle:nil];
	contributionViewController.newflowerDelegate = self;
	UINavigationController* navCon = [[UINavigationController alloc]
		initWithRootViewController:contributionViewController];
	[self.navigationController presentModalViewController:navCon animated:YES];
	[navCon release];
	[contributionViewController release];
}

//	アップデート機能の追加のために以下の3つのメソッドでupdateTriggerに連携する。
- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView {
	[updateTrigger scrollViewWillBeginDragging:scrollView];
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {               // any offset changes
	[updateTrigger scrollViewDidScroll:scrollView];
}

- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate {
	[updateTrigger scrollViewDidEndDragging:scrollView willDecelerate:decelerate];
}

/*
	テーブルを更新する。
*/
-(void)update:(BOOL)foword {
	db.dbDelegate = self;
	int ID = 0;
	if ([result count]) {
		Contribute* instance = [result objectAtIndex:[result count] - 1];
		ID = instance.ID;
	}
	if (foword || (ID == 0)) {
		[result removeAllObjects];
		[db connect];
	} else {
		[db connect:ID forword:NO];
	}
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	self.navigationItem.leftBarButtonItem
		= [self editButtonItem];
	self.navigationItem.rightBarButtonItem
		= [[[UIBarButtonItem alloc]
			 initWithBarButtonSystemItem:UIBarButtonSystemItemAdd
			 target:self 
			 action:@selector(doNewFlower)] autorelease];

	self.tableView.rowHeight = TABLE_ROW_HEIGHT;
	//	アップデート機能の追加。
	updateTrigger = [[UpdateTrigger alloc] init];
	[updateTrigger adapteTrigger:self.tableView];
	updateTrigger.delegte = self;
	
	if (result == nil) {
		result = [[NSMutableArray alloc] init];
		db = [[KonohanaDB alloc] init];
		db.dbDelegate = self;
		if (self.tableView.tag == 1)
			db.filter = ownContributionOnly;
		else if (self.tableView.tag == 2)
			db.filter = ownSuggestionOnly;
	}
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[updateTrigger release];
	[db release];
	[result release];
    [super dealloc];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [result count];
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath 
{
	static NSString *CellIdentifier = @"Cell";    
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		UIView* contentView = cell.contentView;
		UIImageView* imageview = [[UIImageView alloc] initWithFrame:CGRectMake(5,5,TABLE_ROW_HEIGHT - 10,TABLE_ROW_HEIGHT - 10)];
		imageview.tag = tag_Photo;
		imageview.contentMode = UIViewContentModeScaleAspectFill;
		imageview.clipsToBounds = YES;
		[contentView addSubview:imageview];
		UILabel* nameLabel = [[UILabel alloc] initWithFrame:CGRectMake(TABLE_ROW_HEIGHT, 10, 200, 40)];
		nameLabel.tag = tag_Name;
		[contentView addSubview:nameLabel];
		UILabel* commentLabel = [[UILabel alloc] initWithFrame:CGRectMake(TABLE_ROW_HEIGHT, 50, 200, 40)];
		commentLabel.tag = tag_Comment;
		[contentView addSubview:commentLabel];
	}
	//	各ラベルへの掲示板の内容設定。
	Contribute* instance = [result objectAtIndex:indexPath.row];
	UIImageView* imageview = (UIImageView*)[cell viewWithTag:tag_Photo];
	imageview.image = instance.photo;
	UILabel* label = (UILabel*)[cell viewWithTag:tag_Name];
	label.text = instance.name;
	label = (UILabel*)[cell viewWithTag:tag_Comment];
	label.text = instance.comment;
    return cell;
}

/*
	項目の一つが選ばれた。
*/
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)newIndexPath
{
	DetailViewController* ctl = [[DetailViewController alloc] initWithNibName:@"SecondView" bundle:nil];
	UITableViewCell* cell = [tableView cellForRowAtIndexPath:newIndexPath];
	UIImageView* imageview = (UIImageView*)[cell viewWithTag:tag_Photo];
	ctl.image = imageview.image;

	UILabel* name = (UILabel*)[cell viewWithTag:tag_Name];
	ctl.title = name.text;

	ctl.db = db;

	Contribute* instance = [result objectAtIndex:newIndexPath.row];
	ctl.contributeID = instance.ID;
	ctl.comment = instance.comment;
	ctl.own = instance.own;
		
	[self.navigationController pushViewController:ctl animated:YES];
	[ctl release];
}

/*
	ビューが表示されたのでデータベースを検索
*/
-(void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	db.dbDelegate = self;
	[result removeAllObjects];
	[db connect];
}

//	提案が見つかった。
-(void)arrivedContribution:(int)inID photo:(UIImage*)photo name:(NSString*)name comment:(NSString*)comment own:(BOOL)inOwn;
{
	Contribute* instance = [[[Contribute alloc] init] autorelease];
	instance.ID = inID;
	instance.photo = photo;
	instance.name = name;
	instance.comment = comment;
	instance.own = inOwn;
	[result addObject:instance];
}

//	接続完了。
-(void)terminate
{
	[updateTrigger adjust:[result count] * 44.0];
	[self.tableView reloadData];
}

/*
	データベースへの新規投稿
*/
-(void)newFlower:(UIImage*)inImage comment:(NSString*)inComment
{
	if (inImage != nil) {
		[db addContribution:inImage comment:inComment];
	}
	[self.navigationController dismissModalViewControllerAnimated:YES];	
}

/*
	項目削除。
*/
- (void)tableView:(UITableView *)tableView 
	commitEditingStyle:(UITableViewCellEditingStyle)editingStyle 
	forRowAtIndexPath:(NSIndexPath *)indexPath 
{
	Contribute* instance = [result objectAtIndex:indexPath.row];
	[db removeContribution:instance.ID];
	[result removeObjectAtIndex:indexPath.row];
	[tableView deleteRowsAtIndexPaths:
		[NSArray arrayWithObject:indexPath] 
		withRowAnimation:UITableViewRowAnimationTop];
}

- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
	Contribute* instance = [result objectAtIndex:indexPath.row];
	return instance.own;
}
/*
- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath {
	return UITableViewCellEditingStyleInsert;
}
*/

@end
