//
//  KonohanaDB.h
//  konohana_test
//
//  Created by kunii on 09/11/15.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol KonohanaDBDelegate<NSObject>
@optional
//	投稿が見つかった。
-(void)arrivedContribution:(int)inID photo:(UIImage*)photo name:(NSString*)name comment:(NSString*)comment own:(BOOL)inOwn;
//	提案が見つかった。
-(void)arrivedSuggestion:(int)inID name:(NSString*)name comment:(NSString*)comment vote:(int)count;
//	コメント付き支持が見つかった。
-(void)arrivedVote:(int)inID comment:(NSString*)comment;
//	接続終了
-(void)terminate;
@end

@interface KonohanaDB : NSObject {
	id<KonohanaDBDelegate>	dbDelegate;			//	移譲先インスタンス
	int						filter;				//	この変数を設定する事でリストアップする内容を制限する。
}
@property (nonatomic, assign) id<KonohanaDBDelegate>	dbDelegate;
@property (nonatomic, assign) int						filter;

//	無条件検索
-(void)connect;
//	指定した投稿IDより以後または以前（forwordがYESなら以後）に投稿された記事を検索
-(void)connect:(int)inID forword:(BOOL)forword;

//	投稿IDを指定して検索
-(void)connectForSuggestion:(int)inContributionID;
//	指定した投稿IDと提案IDより以後または以前（forwordがYESなら以後）に投稿された提案記事を検索
-(void)connectForSuggestion:(int)inContributionID suggestion:(int)inID forword:(BOOL)forword;

//	投稿ID、提案IDを指定して検索
-(void)connectForVote:(int)inContributionID suggestion:(int)inSuggestionID;
//	指定した投稿IDと提案ID、指示IDより以後または以前（forwordがYESなら以後）に投稿された指示記事を検索
-(void)connectForVote:(int)inContributionID suggestion:(int)inSuggestionID vote:(int)inID forword:(BOOL)forword;

//	投稿の追加
-(void)addContribution:(UIImage*)inImage comment:(NSString*)inComment;
//	指定投稿IDへの提案の追加
-(void)addSuggestion:(int)inContributionID name:(NSString*)inName comment:(NSString*)inComment;
//	指定投稿ID、提案IDへの支持追加
-(void)addVote:(int)inContributionID suggestionID:(int)suggestionID comment:(NSString*)inComment;
//	投稿IDの削除
-(void)removeContribution:(int)inContributionID;
//	提案IDの削除
-(void)removeSuggestion:(int)contributeID suggestionID:(int)inSuggestionID;
//	コメント付き支持IDの削除
-(void)removeVote:(int)inContributionID suggestionID:(int)inSuggestionID voteID:(int)inVoteID;
@end

enum {
	ownContributionOnly = 1,
	ownSuggestionOnly
};
	