//
//  UpdateTrigger.m
//  konohana_test
//
//  Created by kunii on 10/03/30.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "UpdateTrigger.h"


@implementation UpdateTrigger
@synthesize	delegte;

-(void)adjust:(CGFloat)contentsHeight {
	CGRect frame = tableView.tableFooterView.frame;
	frame.size.height = tableView.frame.size.height - contentsHeight;
	if (frame.size.height < 40)
		frame.size.height = 40;
	tableView.tableFooterView.frame = frame;
	UIView* v = tableView.tableFooterView;
	[v retain];
	tableView.tableFooterView = nil;
	tableView.tableFooterView = v;
	[v release];
}
	
-(void)adapteTrigger:(UITableView*)inTableView {
	tableView = inTableView;
	CGRect r = tableView.bounds;
	r.origin.y -= 40;
	r.size.height = 40;
	triggerHeader = [[UILabel alloc] initWithFrame:r]; 
	triggerHeader.text = @"更新する";
	triggerHeader.textAlignment = UITextAlignmentCenter;
	tableView.tableHeaderView = triggerHeader;

	//	トリガーのイメージを埋め込むtriggerHeader
	UIImageView* imageview = [[UIImageView alloc] initWithFrame:CGRectMake(8, (40 - 16) / 2, 16, 16)];
	imageview.image = [UIImage imageNamed:@"arrow.png"];
	imageview.tag = 1;
	[triggerHeader addSubview:imageview];
	[imageview release];
	headerOn = NO;
	
	//	末尾
	r = tableView.bounds;
	r.origin.y = 0;
	r.size.height = 40;
	//	透明なフッタービューを用意
	UIView* baseFotter = [[UIView alloc] initWithFrame:r];
	triggerFooter = [[UILabel alloc] initWithFrame:r]; 
	triggerFooter.textAlignment = UITextAlignmentCenter;
	triggerFooter.text = @"もっと見る";
	//	triggerFooterは透明なフッタービューの底辺にひっつくように指定しaddSubviewする
	triggerFooter.autoresizingMask = UIViewAutoresizingFlexibleTopMargin;
	[baseFotter addSubview:triggerFooter];
	//	透明なフッタービューを指定
	tableView.tableFooterView = baseFotter;
	[baseFotter release];
	imageview = [[UIImageView alloc] initWithFrame:CGRectMake(8, (40 - 16) / 2, 16, 16)];
	imageview.image = [UIImage imageNamed:@"arrow.png"];
	imageview.tag = 1;
	[triggerFooter addSubview:imageview];
	[imageview release];

	footerOn = NO;

	[triggerHeader release];
	[triggerFooter release];

}

- (void)scrollViewWillBeginDragging:(UIScrollView *)scrollView {
	dragging = YES;
	headerOn = NO;
	footerOn = NO;
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {               // any offset changes
	if (dragging == NO)
		return;
	//	ヘッダー側
	CGRect r = tableView.bounds;
	if ((r.origin.y < -50) && (headerOn == NO)) {
		headerOn = YES;
		UIImageView* imageview = (UIImageView*)[triggerHeader viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformRotate(CGAffineTransformIdentity, 3.14);
		[UIView commitAnimations];
		triggerHeader.text = @"手を離すと更新します。";
	}
	if ((r.origin.y > -50) && (headerOn == YES)) {
		headerOn = NO;
		UIImageView* imageview = (UIImageView*)[triggerHeader viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformIdentity;
		[UIView commitAnimations];
		triggerHeader.text = @"更新する";
	}
	//	フッター側
	double tableTail = r.origin.y + r.size.height;
	double triggerTail = triggerFooter.superview.frame.origin.y + triggerFooter.frame.origin.y + triggerFooter.frame.size.height;

	if (triggerTail < tableView.bounds.size.height) {
		//	全項目の高さがテーブルの高さを下回るので、triggerTailをtableView.bounds.size.heightに変更する。
		triggerTail = tableView.bounds.size.height;
	}
	
	if ((tableTail > triggerTail + 20) && (footerOn == NO)) {
		footerOn = YES;
		UIImageView* imageview = (UIImageView*)[triggerFooter viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformRotate(CGAffineTransformIdentity, 3.14);
		[UIView commitAnimations];
		triggerFooter.text = @"手を離すと更新します。";
	}
	if ((tableTail < triggerTail + 20) && (footerOn == YES)) {
		footerOn = NO;
		UIImageView* imageview = (UIImageView*)[triggerFooter viewWithTag:1];
		[UIView beginAnimations:nil context:nil];
		imageview.transform = CGAffineTransformIdentity;
		[UIView commitAnimations];
		triggerFooter.text = @"もっと見る";
	}
}

- (void)scrollViewDidEndDragging:(UIScrollView *)scrollView willDecelerate:(BOOL)decelerate {
	printf("%s %s\n", headerOn?"headerOn":"headerOff", footerOn?"footerOn":"footerOff");
	dragging = NO;
	UIImageView* imageview = (UIImageView*)[triggerFooter viewWithTag:1];
	imageview.transform = CGAffineTransformIdentity;
	imageview = (UIImageView*)[triggerHeader viewWithTag:1];
	imageview.transform = CGAffineTransformIdentity;
	triggerHeader.text = @"更新する";
	triggerFooter.text = @"もっと見る";
	
	if (delegte && ((headerOn || footerOn))) {
		if ([delegte respondsToSelector:@selector(update:)]) {
			[delegte update:(headerOn == YES)];
		}
	}
}

@end
