//
//  ImageKit.h
//  NewFlower
//
//  Created by kunii on 10/01/11.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

/*
	inImageを上下反転し、元画像の底からheightピクセル分で切り取った画像を作成し返す。
	画像はアルファ値が1.0から0.0に変化するマスク（アルファチャネル）がついている。
*/
UIImage* createReflectedImage(
	NSUInteger	height, 
	UIImage*	inImage);

/*
	inImageをinWidth、inHeightにスケーリングした画像を作成し返す。
*/
UIImage* createScaledImage(
	UIImage*	inImage,
	double		inWidth,
	double		inHeight);

/*
	inImageをinCropRectにトリミングしたUIImageを返す。
*/
UIImage* createCropedImage(
	UIImage*	inImage,
	CGRect		inCropRect);
