//
//  NewFlowerNameViewController.m
//  NewFlower
//
//  Created by kunii on 10/03/12.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "NewFlowerNameViewController.h"


@implementation NewFlowerNameViewController
@synthesize image;
@synthesize comment;
@synthesize newflowerNameDelegate;
@synthesize nameDescription, 
			nameView,
			nameCell,
			descriptionCell;

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

//	キャンセル
- (void)cancelModal {
	if ([newflowerNameDelegate respondsToSelector:@selector(newFlowerName:comment:)]) {
		[newflowerNameDelegate newFlowerName:nil comment:nil];
	} else {
		[self.parentViewController dismissModalViewControllerAnimated:YES];	
	}
}

- (void)viewDidLoad {
   [super viewDidLoad];
	self.tableView.tableHeaderView = tableHeaderView;
	self.tableView.allowsSelection = NO;
	imageDescription.text = comment;
	imageView.image = image;
	self.title = @"提案";
	self.navigationItem.leftBarButtonItem 
			= [[[UIBarButtonItem alloc] initWithTitle:@"キャンセル"
			style:UIBarButtonItemStylePlain target:self 
			action:@selector(cancelModal)] autorelease];
}

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	[tableHeaderView release];
	[imageView release];
	[imageDescription release];
	[nameDescription release];
	[nameView release];
	[nameCell release];
	[descriptionCell release];
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 2;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 1;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    if (section == 0) {
        return @"提案する名前";
	} else if (section == 1) {
		return @"説明";
    }
    return nil;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView 
	cellForRowAtIndexPath:(NSIndexPath *)indexPath {

	UITableViewCell *cell;
	if (indexPath.section == 0) {
		cell = nameCell;
	} else {
		cell = descriptionCell;
	}
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView 
	heightForRowAtIndexPath:(NSIndexPath *)indexPath {
	if (indexPath.section == 1)
		return 100.0;
	return 50;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
    [super dealloc];
}

-(void)suggestion:(id)sender {
	if ([newflowerNameDelegate respondsToSelector:@selector(newFlowerName:comment:)]) {
		[newflowerNameDelegate newFlowerName:nameView.text comment:nameDescription.text];
	} else {
		[self.parentViewController dismissModalViewControllerAnimated:YES];	
	}
}

- (void)showSuggestionButton {
	if (nameView.text && nameView.text.length > 0) {
		UIBarButtonItem *doneButton = 
			[[UIBarButtonItem alloc] initWithTitle:@"提案" 
			style:UIBarButtonItemStyleDone target:self action:@selector(suggestion:)];
		self.navigationItem.rightBarButtonItem = doneButton;
		[doneButton release];
	} else {
		self.navigationItem.rightBarButtonItem = nil;
	}
}

- (void)textFieldDidBeginEditing:(UITextField *)textField {
	self.navigationItem.rightBarButtonItem = nil;
}

-(BOOL)textFieldShouldReturn:(UITextField*)sender {
	[sender resignFirstResponder];
	[self showSuggestionButton];
	return YES;
}


-(void)nameDescriptionDone:(id)sender {
	[ nameDescription resignFirstResponder];
	[self showSuggestionButton];
}

- (void)textViewDidBeginEditing:(UITextView *)textView {
	//	テキスト入力完了通知用ボタンを用意。
	UIBarButtonItem *doneButton = 
		[[UIBarButtonItem alloc] initWithTitle:@"入力完了" 
		style:UIBarButtonItemStyleDone target:self action:@selector(nameDescriptionDone:)];
	self.navigationItem.rightBarButtonItem = doneButton;
	[doneButton release];
}

@end
