//
//  NewFlowerViewController.h
//  NewFlower
//
//  Created by kunii on 10/03/16.
//  Copyright 2010 Apple Inc. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol NewFlowerViewControllerDelegate<NSObject>
-(void)newFlower:(UIImage*) inImage comment:(NSString*)inComment;
@end

@interface NewFlowerViewController : UITableViewController<
	UIActionSheetDelegate, 
	UINavigationControllerDelegate, 
	UIImagePickerControllerDelegate, 
	UITextViewDelegate> {
	IBOutlet UIView *					tableHeaderView;	//	テーブルヘッダー
	IBOutlet UIButton*					imageButton;		//	写真表示とカメラ/アルバム選択ボタンを兼ねる。
	id<NewFlowerViewControllerDelegate>	newflowerDelegate;	//	移譲先
	UITextView*							commentView;		//	登録するコメント
	UIImage*							newImage;			//	登録するイメージ
}

//	写真取り込み
-(IBAction)captureImage;

@property (nonatomic, retain) id<NewFlowerViewControllerDelegate>	newflowerDelegate;

@end
