//
//  NewFlowerViewController.m
//  NewFlower
//
//  Created by kunii on 10/03/16.
//  Copyright 2010 Apple Inc. All rights reserved.
//

#import "NewFlowerViewController.h"
#import "ImageKit.h"

@implementation NewFlowerViewController
@synthesize newflowerDelegate;

#pragma mark -
#pragma mark View lifecycle

- (void)viewDidLoad {
    [super viewDidLoad];

	self.title = @"投稿";
	self.tableView.tableHeaderView = tableHeaderView;
	self.navigationItem.leftBarButtonItem 
			= [[[UIBarButtonItem alloc] initWithTitle:@"キャンセル"
			style:UIBarButtonItemStylePlain target:self 
			action:@selector(cancelModal)] autorelease];
}


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
    [super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
}
*/
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


#pragma mark -
#pragma mark Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    // Return the number of sections.
    return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // Return the number of rows in the section.
    return 1;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    if (section == 0) {
        return @"撮影状況の説明";
    }
    return nil;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"NewFlowerDescriptionCell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
    }
    
	//	「説明」複数行入力のUITextViewを利用
	commentView = [[[UITextView alloc] initWithFrame:CGRectInset(cell.contentView.bounds, 10, 10)] autorelease];
	[cell.contentView addSubview:commentView];
	commentView.delegate = self;
	commentView.autoresizingMask = 
		UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	
    return cell;
}


/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


#pragma mark -
#pragma mark Table view delegate


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
	[newImage release];
    [super dealloc];
}


/*
	画像を選択（撮影）し
*/
-(IBAction)captureImage
{
	if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera] == YES) {	//　カメラ機能が使えるか？
		UIActionSheet* action = [[UIActionSheet alloc] initWithTitle:@"画像を選択" 
			delegate:self cancelButtonTitle:@"キャンセル" 
			destructiveButtonTitle:nil 
			otherButtonTitles:@"写真を撮る",@"既存の項目を選択",nil] ;
		if (action) {
			action.actionSheetStyle = UIBarStyleBlackTranslucent;	// スタイル設定
			[action showInView:self.view];				//　方法選択のアクションシートを開く
			[action release];
		}
	} else {
		//	カメラがないので無条件にアルバムから選択させる。
		[self actionSheet:nil clickedButtonAtIndex:1];
	}
}

/*
	カメラ撮影、アルバムから選択
*/
- (void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex
{
	if (buttonIndex == 2) {									// キャンセルボタン
		return;
	}
	int types[] = {
		UIImagePickerControllerSourceTypeCamera,			//	カメラ撮影
		UIImagePickerControllerSourceTypePhotoLibrary		//	アルバムから選択
	};
	UIImagePickerController* picker = [[UIImagePickerController alloc] init];
	if (picker) {
		picker.allowsImageEditing = YES;		//　画像のトリミングを許可
		picker.sourceType = types[buttonIndex];	//　カメラ撮影かアルバムから選択を指定
		picker.delegate = self;
		[self presentModalViewController:picker animated:YES];
		[picker release];
	}
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {
	[newImage release];
	NSValue* value = [info objectForKey:UIImagePickerControllerCropRect];
	newImage = createCropedImage([info objectForKey:UIImagePickerControllerOriginalImage], [value CGRectValue]);
	[newImage retain];										//	登録時に渡すために保持する。

	//	自分が作りたい画像の大きさを決めて描画領域を作る。
	CGRect bounds = [imageButton contentRectForBounds:imageButton.bounds];
	double wide = bounds.size.height * 1.0;
	CGSize size = newImage.size;
	CGFloat ratio = 0;
	if (size.width < size.height) {		//	縦長なので、高さで比率計算。
		ratio = wide / size.width;
	} else {							//	横長。
		ratio = wide / size.height;
	}
	//	計算した描画領域を指定して描画準備。
	UIImage* scaledImage = createScaledImage(newImage, ratio * size.width, ratio * size.height);
	//	スケーリングされたUIImageを設定。
	[imageButton setImage:scaledImage forState:UIControlStateNormal];
	//	説明文は消す。
	[imageButton setTitle:nil forState:UIControlStateNormal];
	
	self.navigationItem.rightBarButtonItem 
			= [[[UIBarButtonItem alloc] initWithTitle:@"投稿する"
			style:UIBarButtonItemStylePlain target:self 
			action:@selector(endModal)] autorelease];
	[self.parentViewController dismissModalViewControllerAnimated:YES];	//　画像ピッカーを閉じる
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
	[self dismissModalViewControllerAnimated:YES];	//　画像ピッカーを閉じる
}

//	キャンセルなのでnewFlower:nil comment:nilとする。
- (void)cancelModal {
	if ([newflowerDelegate respondsToSelector:@selector(newFlower:comment:)]) {
		[newflowerDelegate newFlower:nil comment:nil];
	} else {
		[self.parentViewController dismissModalViewControllerAnimated:YES];	
	}
}

//	投稿なので、newImageを委譲先に渡す。
- (void)endModal {
	if ([newflowerDelegate respondsToSelector:@selector(newFlower:comment:)]) {
		[newflowerDelegate newFlower:newImage comment:commentView.text];
	}
}

-(void)commentDone:(id)sender {
	[commentView resignFirstResponder];
	self.navigationItem.rightBarButtonItem 
			= [[[UIBarButtonItem alloc] initWithTitle:@"投稿する"
			style:UIBarButtonItemStylePlain target:self 
			action:@selector(endModal)] autorelease];
}

- (void)textViewDidBeginEditing:(UITextView *)textView {
	//	テキスト入力完了通知用ボタンを用意。
	UIBarButtonItem *doneButton = 
		[[UIBarButtonItem alloc] initWithTitle:@"入力完了" 
		style:UIBarButtonItemStyleDone target:self action:@selector(commentDone:)];
	self.navigationItem.rightBarButtonItem = doneButton;
	[doneButton release];
}

@end

