//
//  htmlParserViewController.m
//  htmlParser
//
//  Created by kunii on 10/05/30.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "htmlParserViewController.h"
#import "konohanaParser.h"
#import "POSTRequest.h"

@implementation htmlParserViewController

//	みつけた投稿IDを削除
-(void)deleteContribute:(int)ID {
	NSURLRequest* deleteRequest = [NSURLRequest requestWithURL:
		[NSURL URLWithString:[NSString stringWithFormat:@"http://localhost/konohana/mainlist.php?delete_id=%d", ID]]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:deleteRequest returningResponse:&response error:&error];
}

//	みつけた提案IDを削除
-(void)deleteSuggestion:(int)ID sugID:(int)sugID {
	NSURLRequest* deleteRequest = [NSURLRequest requestWithURL:
		[NSURL URLWithString:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d&delete_id=%d", ID, sugID]]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:deleteRequest returningResponse:&response error:&error];
}

//	みつけた支持IDを削除
-(void)deleteVoteComment:(int)ID sugID:(int)sugID voteID:(int)voteID{
	NSURLRequest* deleteRequest = [NSURLRequest requestWithURL:
		[NSURL URLWithString:[NSString stringWithFormat:@"http://localhost/konohana/suggest.php?contribution_id=%d&suggestion_id=%d&delete_id=%d", ID, sugID, voteID]]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:deleteRequest returningResponse:&response error:&error];
}

//	投稿後の投稿リストを解析し、削除できる投稿の投稿IDを取り出す。
-(int)getContributeID {
	konohanaParser* parser_contribute =[konohanaParser parserWithType:parse_contribute];
	[parser_contribute parse:@"http://localhost/konohana/mainlist.php"];
	for (id dic in parser_contribute.list) {
		if ([dic valueForKey:@"deletable"]) {
			return [[dic valueForKey:@"ID"] intValue];
		}
	}
	return 0;
}

//	提案リストを解析し、一番最後の提案IDを取り出す
-(int)getSuggestionID:(int)ID {
	konohanaParser* parser_suggestion =[konohanaParser parserWithType:parse_suggestion];
	[parser_suggestion parse:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d", ID]];
	id suggestion = [parser_suggestion.list lastObject];
	int suggestionID = [[suggestion valueForKey:@"ID"] intValue];
	return suggestionID;
}

//	支持リストを解析し、一番最後の支持IDを取り出す
-(int)getVoteID:(int)ID suggestionID:(int)suggestionID {
	konohanaParser* parser_vote =[konohanaParser parserWithType:parse_vote];
	[parser_vote parse:[NSString stringWithFormat:@"http://localhost/konohana/suggest.php?contribution_id=%d&suggestion_id=%d", ID, suggestionID]];
	id vote = [parser_vote.list lastObject];
	int voteID = [[vote valueForKey:@"ID"] intValue];
	return voteID;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	NSMutableURLRequest* loginRequest = [POSTRequest requestLogin:@"http://localhost/konohana/login.php" name:@"xcc" password:@"xcc"];

	//	今回は順々に実行する必要があるので、簡単な同期版を使う。
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:loginRequest returningResponse:&response error:&error];

	//	投稿をおこなう
	UIImage* image = [UIImage imageNamed:@"test.jpg"];
	NSURLRequest* sendImage = [POSTRequest requestContribute:@"http://localhost/konohana/mainlist.php" image:image comment:@"test"];
	(void)[NSURLConnection sendSynchronousRequest:sendImage returningResponse:&response error:&error];
	//	投稿後の投稿リストを解析し、削除できる投稿の投稿IDを取り出す。
	int ID = [self getContributeID];
	//	提案をおこなう
	NSURLRequest* sendSuggestion = [POSTRequest requestSuggestion:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d", ID]
			candidate:@"候補名" description:@"説明"];
	(void)[NSURLConnection sendSynchronousRequest:sendSuggestion returningResponse:&response error:&error];
	//	提案リストを解析し、一番最後の提案IDを取り出す。
	int suggestionID = [self getSuggestionID:ID];
	//	みつけた提案IDに対し支持をおこなう。
	NSURLRequest* vote = [POSTRequest requestVote:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d&suggestion_id=%d", ID, suggestionID]];
	[NSURLConnection sendSynchronousRequest:vote returningResponse:&response error:&error];
	//	みつけた提案IDに対しコメント付き支持をおこなう。
	NSURLRequest* voteWithComment = [POSTRequest requestVote:[NSString stringWithFormat:@"http://localhost/konohana/suggest.php?contribution_id=%d&suggestion_id=%d", ID, suggestionID]
		withComment:@"支持コメント"];
	[NSURLConnection sendSynchronousRequest:voteWithComment returningResponse:&response error:&error];
	//	支持リストを解析し、一番最後の支持IDを取り出す。
	int voteID = [self getVoteID:ID suggestionID:suggestionID];

	//	みつけた支持IDの支持を削除。
	[self deleteVoteComment:ID sugID:suggestionID voteID:voteID];
	//	みつけた提案IDの提案を削除。
	[self deleteSuggestion:ID sugID:suggestionID];
	//	みつけた投稿IDの投稿を削除。
	[self deleteContribute:ID];
	
	//	ログアウトする。
	NSURLRequest* request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://localhost/konohana/logout.php"]];
	(void)[NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
	
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end


