//
//  KonohanaDB.m
//  konohana_test
//
//  Created by kunii on 09/11/15.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "KonohanaDB.h"
#import "POSTRequest.h"
#import "konohanaParser.h"

@implementation KonohanaDB

@synthesize dbDelegate, filter;

/*
	初期化
*/
-(id)init {
	if (self = [super init]) {
		NSMutableURLRequest* loginRequest = [POSTRequest requestLogin:@"http://localhost/konohana/login.php" name:@"xcc" password:@"xcc"];
		//	今回は順々に実行する必要があるので、簡単な同期版を使う。
		NSURLResponse* response;
		NSError* error;
		(void)[NSURLConnection sendSynchronousRequest:loginRequest returningResponse:&response error:&error];		
	}
	return self;
}

/*
	解放
*/
-(void)dealloc {
	//	ログアウトする。
	NSURLRequest* request = [NSURLRequest requestWithURL:[NSURL URLWithString:@"http://localhost/konohana/logout.php"]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
	[super dealloc];
}

/*
	移譲先に投稿発見を通知。
*/
-(void)handleArrivedContribution:(int)inID photo:(UIImage*)photo name:(NSString*)name comment:(NSString*)comment own:(BOOL)inOwn {
	if ([dbDelegate respondsToSelector:@selector(arrivedContribution:photo:name:comment:own:)]) {
		[dbDelegate arrivedContribution:inID photo:photo name:name comment:comment own:inOwn];
	}
}

/*
	移譲先に提案発見を通知。
*/
-(void)handleArrivedSuggestion:(int)inID name:(NSString*)name comment:(NSString*)comment vote:(int)inVoteCount {
	if ([dbDelegate respondsToSelector:@selector(arrivedSuggestion:name:comment:vote:)]) {
		[dbDelegate arrivedSuggestion:(int)inID name:name comment:comment vote:inVoteCount];
	}
}

/*
	移譲先にコメント付き支持発見を通知。
*/
-(void)handleArrivedVote:(int)inID comment:(NSString*)comment {
	if ([dbDelegate respondsToSelector:@selector(arrivedVote:comment:)]) {
		[dbDelegate arrivedVote:(int)inID comment:comment];
	}
}

/*
	移譲先に終了を通知。
*/
-(void)handleTerminate
{
	if ([dbDelegate respondsToSelector:@selector(terminate)]) {
		[dbDelegate terminate];
	}
}

//	無条件接続
-(void)connect
{
	[self connect:-1 forword:YES];
}

/*
 http://localhost/konohana/mainlist.php?top_id=13
 http://localhost/konohana/mainlist.php?bottom_id=14
 */
-(void)connect:(int)inID forword:(BOOL)forword {
	//	投稿後の投稿リストを解析し、削除できる投稿の投稿IDを取り出す。
	konohanaParser* parser_contribute =[konohanaParser parserWithType:parse_contribute];
	NSString* page = nil;
	if (inID == -1) {
		page = @"";
	} else {
		if (forword) {
			page = [NSString stringWithFormat:@"?top_id=%d", inID]; 
		} else {
			page = [NSString stringWithFormat:@"?bottom_id=%d", inID]; 
		}
	}
	[parser_contribute parse:[NSString stringWithFormat:@"http://localhost/konohana/mainlist.php%@", page]];
	for (id dic in parser_contribute.list) {
		NSLog(@"dic=%@\n",dic);
		NSURL* url = [NSURL URLWithString:[dic valueForKey:@"url"] relativeToURL:[NSURL URLWithString:@"http://localhost/konohana/mainlist.php"]];
		[self handleArrivedContribution:[[dic valueForKey:@"ID"] intValue] 
								  photo:[[UIImage alloc] initWithData:[NSData dataWithContentsOfURL:url]]
								   name:[dic valueForKey:@"name"] 
								comment:[dic valueForKey:@"comment"] 
									own:[[dic valueForKey:@"deletable"] boolValue]];
	}
	[self handleTerminate];
}

//	投稿IDを指定して検索
-(void)connectForSuggestion:(int)inContributionID {
	[self connectForSuggestion:inContributionID suggestion:-1 forword:YES];
}

//	指定した投稿IDと提案IDより以後または以前（forwordがYESなら以後）に投稿された提案記事を検索
/*
http://localhost/konohana/suggestlist.php?contribution_id=10&top_id=55&vote_count=1
http://localhost/konohana/suggestlist.php?contribution_id=10&bottom_id=56&vote_count=1
 */
-(void)connectForSuggestion:(int)inContributionID suggestion:(int)inID forword:(BOOL)forword {
	//	投稿後の投稿リストを解析し、削除できる投稿の投稿IDを取り出す。
	konohanaParser* parser_suggestion =[konohanaParser parserWithType:parse_suggestion];
	NSString* page = nil;
	if (inID == -1) {
		page = @"";
	} else {
		if (forword) {
			page = [NSString stringWithFormat:@"&top_id=%d&vote_count=%d", inID, 1]; 
		} else {
			page = [NSString stringWithFormat:@"&bottom_id=%d&vote_count=%d", inID, 1]; 
		}
	}
	[parser_suggestion parse:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d%@", 
							  inContributionID, page]];
	BOOL firstItem = YES;
	for (id dic in parser_suggestion.list) {
		if ((inID != -1) && (firstItem == YES)) {
			firstItem = NO;
			continue;
		}
		[self handleArrivedSuggestion:[[dic valueForKey:@"ID"] intValue]
								 name:[dic valueForKey:@"name"]
							  comment:@""
								 vote:[[dic valueForKey:@"vote"] intValue]];
	}
	[self handleTerminate];
}

//	投稿ID、提案IDを指定して検索
-(void)connectForVote:(int)inContributionID suggestion:(int)inSuggestionID {
	[self connectForVote:inContributionID suggestion:inSuggestionID vote:-1 forword:YES];
}

//	指定した投稿IDと提案ID、指示IDより以後または以前（forwordがYESなら以後）に投稿された支持記事を検索		getVoteID
/*
 http://localhost/konohana/suggest.php?contribution_id=13&suggestion_id=50&top_id=
 http://localhost/konohana/suggest.php?contribution_id=13&suggestion_id=50&bottom_id=
 */
-(void)connectForVote:(int)inContributionID suggestion:(int)inSuggestionID vote:(int)inID forword:(BOOL)forword {
	konohanaParser* parser_vote =[konohanaParser parserWithType:parse_vote];
	NSString* page = nil;
	if (inID == -1) {
		page = @"";
	} else {
		if (forword) {
			page = [NSString stringWithFormat:@"&top_id=%d", inID]; 
		} else {
			page = [NSString stringWithFormat:@"&bottom_id=%d", inID]; 
		}
	}
	[parser_vote parse:[NSString stringWithFormat:@"http://localhost/konohana/suggest.php?contribution_id=%d&suggestion_id=%d%@", 
						inContributionID, inSuggestionID, page]];
	for (id dic in parser_vote.list) {
		[self handleArrivedVote:[[dic valueForKey:@"ID"] intValue]
						comment:[dic valueForKey:@"comment"]];
	}
	[self handleTerminate];
}

//	投稿の追加
-(void)addContribution:(UIImage*)inImage comment:(NSString*)comment
{
	NSURLRequest* sendImage = [POSTRequest requestContribute:@"http://localhost/konohana/mainlist.php" 
													   image:inImage 
													 comment:comment];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:sendImage returningResponse:&response error:&error];
}

//	指定投稿IDへの提案の追加
-(void)addSuggestion:(int)inContributionID name:(NSString*)inName comment:(NSString*)inComment {
	//	提案をおこなう
	NSURLRequest* sendSuggestion = [POSTRequest requestSuggestion:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d", 
																   inContributionID]
														candidate:inName description:inComment];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:sendSuggestion returningResponse:&response error:&error];
}

//	指定投稿ID、提案IDへの支持追加
-(void)addVote:(int)inContributionID suggestionID:(int)inSuggestionID comment:(NSString*)inComment {
	NSURLRequest* vote = nil;
	if (inComment) {
		//	みつけた提案IDに対しコメント付き支持をおこなう。
		vote = [POSTRequest requestVote:[NSString stringWithFormat:@"http://localhost/konohana/suggest.php?contribution_id=%d&suggestion_id=%d", 
																  inContributionID, inSuggestionID]
													 withComment:inComment];
	} else {
		//	みつけた提案IDに対し支持をおこなう。
		vote = [POSTRequest requestVote:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d&suggestion_id=%d", 
										 inContributionID, inSuggestionID]];
	}
	NSURLResponse* response;
	NSError* error;
	[NSURLConnection sendSynchronousRequest:vote returningResponse:&response error:&error];
}

//	投稿IDの削除		deleteContribute
-(void)removeContribution:(int)inContributionID {
	NSURLRequest* deleteRequest = [NSURLRequest requestWithURL:
								   [NSURL URLWithString:[NSString stringWithFormat:@"http://localhost/konohana/mainlist.php?delete_id=%d", 
														 inContributionID]]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:deleteRequest returningResponse:&response error:&error];
}

//	提案IDの削除			deleteSuggestion
-(void)removeSuggestion:(int)inContributionID suggestionID:(int)inSuggestionID {
	NSURLRequest* deleteRequest = [NSURLRequest requestWithURL:
								   [NSURL URLWithString:[NSString stringWithFormat:@"http://localhost/konohana/suggestlist.php?contribution_id=%d&delete_id=%d", 
														 inContributionID, inSuggestionID]]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:deleteRequest returningResponse:&response error:&error];
}

//	コメント付き支持IDの削除		deleteVoteComment
-(void)removeVote:(int)inContributionID suggestionID:(int)inSuggestionID voteID:(int)inVoteID {
	NSURLRequest* deleteRequest = [NSURLRequest requestWithURL:
								   [NSURL URLWithString:[NSString stringWithFormat:@"http://localhost/konohana/suggest.php?contribution_id=%d&suggestion_id=%d&delete_id=%d", 
														 inContributionID, inSuggestionID, inVoteID]]];
	NSURLResponse* response;
	NSError* error;
	(void)[NSURLConnection sendSynchronousRequest:deleteRequest returningResponse:&response error:&error];
}

@end
