//
//  POSTRequest.m
//  htmlParser
//
//  Created by kunii on 10/07/26.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "POSTRequest.h"

static NSString* boundary = @"xcc2010";

@implementation POSTRequest

// URLを指定する
+(NSMutableURLRequest*)request:(NSString*)url {
	NSMutableURLRequest* request = [[NSMutableURLRequest alloc] init];
	[request setURL:[NSURL URLWithString:url]];
	[request setHTTPMethod:@"POST"];
	NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
	[request addValue:contentType forHTTPHeaderField: @"Content-Type"];
	return request;
}

//	文字列パラメータ追加
+(void)append:(NSMutableData*)body name:(NSString*)name value:(NSString*)value {
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"%@\"\r\n", name] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithString:@"Content-Type: text/plain;charset=utf8\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[value dataUsingEncoding:NSUTF8StringEncoding]];
}

//	画像パラメータ追加
+(void)appendImage:(NSMutableData*)body name:(NSString*)name filename:(NSString*)filename imageData:(NSData*)imageData {
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"%@\"; filename=\"%@\"\r\n", name, filename] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithString:@"Content-Type: application/octet-stream\r\n\r\n"] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[NSData dataWithData:imageData]];
}

//	終了境界文字列追加
+(void)appendTerminater:(NSMutableData*)body {
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
}

/*
	ログイン
*/
+(NSMutableURLRequest*)requestLogin:(NSString*)url name:(NSString*)name password:(NSString*)password {
	NSMutableURLRequest* request = [self request:url];	// URLを指定する
	//	内容部作成
	NSMutableData *body = [NSMutableData data];
	[self append:body name:@"handle_name" value:name];	//	name=nameの設定
	[self append:body name:@"password" value:password];	//	password=passwordの設定
	[self append:body name:@"submit_login" value:@"1"];	//	submit_login=1の設定
	[self appendTerminater:body];
	//	内容物追加
	[request setHTTPBody:body];
	return [request autorelease];						//	new,copy,alloc規約にしたがってautoreleaseしてから返す。
}

/*
	投稿
*/
+(NSMutableURLRequest*)requestContribute:(NSString*)url image:(UIImage*)image comment:(NSString*)comment {
	NSMutableURLRequest* request = [self request:url];	// URLを指定する
	//	内容部作成
	NSMutableData *body = [NSMutableData data];
	[self append:body name:@"comment" value:comment];	//	comment=commentの設定
	NSData *imageData = UIImageJPEGRepresentation(image, 0.5);
	[self appendImage:body name:@"img_path" filename:@"ipodfile.jpg" imageData:imageData];
	[self append:body name:@"up" value:@"1"];			//	up=1の設定
	[self appendTerminater:body];
	//	内容物追加
	[request setHTTPBody:body];
	return [request autorelease];						//	new,copy,alloc規約にしたがってautoreleaseしてから返す。
}

/*
	提案
*/
+(NSMutableURLRequest*)requestSuggestion:(NSString*)url candidate:(NSString*)candidate description:(NSString*)description {
	NSMutableURLRequest* request = [self request:url];	// URLを指定する
	//	内容部作成
	NSMutableData *body = [NSMutableData data];
	[self append:body name:@"name" value:candidate];	//	name=candidateの設定
	[self append:body name:@"comment" value:description];	//	comment=descriptionの設定
	[self append:body name:@"suggest" value:@"1"];		//	suggest=1の設定
	[self appendTerminater:body];
	//	内容物追加
	[request setHTTPBody:body];
	return [request autorelease];						//	new,copy,alloc規約にしたがってautoreleaseしてから返す。
}

/*
	支持
*/
+(NSMutableURLRequest*)requestVote:(NSString*)url {
	NSMutableURLRequest* request = [self request:url];	// URLを指定する
	//	内容部作成
	NSMutableData *body = [NSMutableData data];
	[self append:body name:@"vote" value:@"1"];			//	suggest=1の設定
	[self appendTerminater:body];
	//	内容物追加
	[request setHTTPBody:body];
	return [request autorelease];						//	new,copy,alloc規約にしたがってautoreleaseしてから返す。
}

/*
	コメント付き支持
*/
+(NSMutableURLRequest*)requestVote:(NSString*)url withComment:(NSString*)comment {
	NSMutableURLRequest* request = [self request:url];	// URLを指定する
	//	内容部作成
	NSMutableData *body = [NSMutableData data];
	[self append:body name:@"comment" value:comment];	//	comment=commentの設定
	[self append:body name:@"vote" value:@"1"];			//	vote=1の設定
	[self appendTerminater:body];
	//	内容物追加
	[request setHTTPBody:body];
	return [request autorelease];						//	new,copy,alloc規約にしたがってautoreleaseしてから返す。
}

@end
